using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Drawing;

// Ȃ̂ɍNXłB
// AlŌJĂ\[XR[h
// Rsyēł邩܂B
// 肢܂B

namespace Kst32bfont
{
	class Kst32bfont
	{
		public string FontPath
		{
			get { return fontPath; }
			set { fontPath = value; }
		}


        public int ConvertCharCode(char charcode)
        {
            //1؂oJISR[hɕϊ
            //2oCg͑OɃGXP[vV[PX3oCgt8oCgɂȂB
            Encoding enc = Encoding.GetEncoding("iso-2022-jp");
            string str1char = charcode.ToString();
            byte[] buff = enc.GetBytes(str1char);
            int code;
            if (buff.Length == 1)
            {
                code = buff[0];
            }
            else
            {
                code = ((buff[3]) << 8) + buff[4];
            }
            return code;
        }

		public ArrayList GetFontLineData(string str,out int stringWidth)
		{
			if (arrayFontElm == null){
				stringWidth = 0;
				return null;
			}
			ArrayList listLine = new ArrayList();
			int length = str.Length;
			Encoding enc = Encoding.GetEncoding("iso-2022-jp");
			int xOffset = 0;
			for (int i = 0; i < length; i++) {
				//1؂oJISR[hɕϊ
				//2oCg͑OɃGXP[vV[PX3oCgt8oCgɂȂB
				string str1char = str.Substring(i, 1); ;
				byte[] buff = enc.GetBytes(str1char);
				int code;
				int charWidth;
				if (buff.Length == 1) {
					code = buff[0];
					charWidth = 18;
				} else {
					code = ((buff[3]) << 8) + buff[4];
					charWidth = 36;
				}
				listLine = GenerateLineData(code, xOffset);
				xOffset += charWidth;
			}
			stringWidth = xOffset;
			return listLine;
		}


		ArrayList GenerateLineData(int code, int xOffset)
		{
			//****20(Hex)     : Terminator 
			//****    21-26,28-3F : Move to X=0--29 
			//****    40-5B,5E-5F : Draw to X=0--29 
			//****    60-7D       : Next X to 0--29 
			//****    7E,A1-BF    : Move to Y=0--31 
			//****    C0-DF       : Draw to Y=0--31 
            ArrayList chrLine = new ArrayList();
			Kst32bFontElm elm = getFont(code);
			if (elm == null) return chrLine ;
			Point pCurrentPos = new Point(0, 0);
			Point pDrawTo = new Point(0,0);
			int count = elm.count;
			for (int i = 0; i < count; i++) {
				bool bFlush = false;
				int dat = elm.fontData[i];
				//Move to X
				if (dat >= 0x21 && dat <= 0x26) {
					pCurrentPos.X = dat - 0x21;
					pDrawTo.X = pCurrentPos.X;
				} else if (dat >= 0x28 && dat <= 0x3F) {
					pCurrentPos.X = dat - 0x22;
					pDrawTo.X = pCurrentPos.X;
				} else
					//Move to Y
					if (dat == 0x7E) {
						pCurrentPos.Y = 0;
						pDrawTo.Y = pCurrentPos.Y;
					} else if (dat >= 0xA1 && dat <= 0xBF) {
						pCurrentPos.Y = dat - 0xA0;
						pDrawTo.Y = pCurrentPos.Y;
					} else
						//Next X
						if (dat >= 0x60 && dat <= 0x7D) {
							pDrawTo.X = dat - 0x60;
						} else
							//Draw to X
							if (dat >= 0x40 && dat <= 0x5B) {
								pDrawTo.X = dat - 0x40;
								bFlush = true;
							} else if (dat >= 0x5E && dat <= 0x5F) {
								pDrawTo.X = dat - 0x42;
								bFlush = true;
							} else
								//Draw to Y
								if (dat >= 0xC0 && dat <= 0xDF) {
									pDrawTo.Y = dat - 0xC0;
									bFlush = true;
								}

				if (bFlush) {
					LineData lineData = new LineData(	pCurrentPos.X+xOffset,pCurrentPos.Y, 
														pDrawTo.X+xOffset,pDrawTo.Y);
                    chrLine.Add(lineData);
					pCurrentPos = pDrawTo;
				}
			}
			return chrLine;
		}


		public bool LoadFont()
		{
			arrayFontElm = null;
			if (fontPath.Length == 0) return false;

			FileStream fs = null;

			try {
				fs = new FileStream(fontPath, FileMode.Open, FileAccess.Read);
				readfile(fs);
			}
			catch (Exception) {
				return false;
			}
			finally {
				if (fs != null) {
					fs.Close();
				}
			}

			//Kst32bFontElm elm = getFont(0x592e);

			return true;
		}

		public Kst32bFontElm getFont(int code)
		{
			if (arrayFontElm == null) return null;
			Kst32bFontElm elm = new Kst32bFontElm();
			elm.code = code;
			IComparer comparer = new Kst32bFontElmComp();
			int index = Array.BinarySearch(arrayFontElm, elm, comparer);
			if (index < 0) return null;
			return arrayFontElm[index];
		}



		private int readfile(FileStream fs)
		{
			int lineCount = 0;
			byte[] buff;
			int charCount;
			arrayFontElm = null;

			LinkedList<Kst32bFontElm> listFontElm = new LinkedList<Kst32bFontElm>();

			while ((charCount = readline(fs, out buff)) != -1) {
				if (buff[0] == '*') continue;
				Kst32bFontElm elm = evalFontLine(buff);
				listFontElm.AddLast(elm);
				lineCount++;
			}

			//XgzɃRs[
			arrayFontElm = new Kst32bFontElm[lineCount];
			int i = 0;
			foreach (Kst32bFontElm elm in listFontElm) {
				arrayFontElm[i] = elm;
				i++;
			}

			//R[hɃ\[g(tHgt@C\[gς݂Ȃ̂ŗvȂ)
			IComparer comparer = new Kst32bFontElmComp();
			Array.Sort(arrayFontElm, 0, lineCount, comparer);
			return lineCount;
		}

		private Kst32bFontElm evalFontLine(byte[] buff)
		{
			char[] codeStr = new char[4];
			for(int i=0;i<4;i++){
				if(buff[i]==0)return null;
				codeStr[i] = (char)buff[i];
			}
			if (buff[4] == 0) return null;
			//codeStr[4] = '\0';

			string str = new string(codeStr);
			int code = Convert.ToInt32(str, 16);
			int count = 0;
			int index = 5;
			while(buff[index]!=0x20 && buff[index]!=0){
				count++;
				index++;
			}
			Kst32bFontElm elm = new Kst32bFontElm();
			elm.code = code;
			elm.count = count;
			elm.fontData = new byte[count];
			index = 5;
			int j = 0;
			while(buff[index]!=0x20 && buff[index]!=0){
				elm.fontData[j]=buff[index];
				j++;
				index++;
			}
			return elm;
		}


		private int readline(FileStream fs, out byte[] buff)
		{
			buff = null;
			byte[] localBuff = new byte[1024];
			int c;
			do {
				c = fs.ReadByte();
				if (c == -1) return -1;
			} while (c == 0x0d || c == 0x0A);

			int readCount = 0;
			do {
				if (readCount < 1023) {
					localBuff[readCount] = (byte)c;
					readCount++;
				}
				c = fs.ReadByte();
			} while (c != 0x0d && c != 0x0A && c != -1);
			buff =	new byte[readCount+1];
			for(int i=0;i<readCount;i++){
				buff[i] = localBuff[i];
			}
			buff[readCount]=0;
			return readCount;
		}

		private Kst32bFontElm[] arrayFontElm;

		private class Kst32bFontElmComp : IComparer
		{
			public int Compare(Object x, Object y)
			{
				return ((Kst32bFontElm)x).code - ((Kst32bFontElm)y).code;
			}
		}


		private static string fontPath = "";
	}

	class Kst32bFontElm
	{
		public Kst32bFontElm()
		{
			code = 0;
			count = 0;
			fontData = null;
		}

		public int code;
		public int count;
		public byte[] fontData;
	}

	public struct LineData
	{
		public LineData(int x0, int y0, int x1, int y1)
		{
			p0 = new Point(x0, y0);
			p1 = new Point(x1, y1);
		}

		public LineData(Point _p0, Point _p1)
		{
			p0 = _p0;
			p1 = _p1;
		}


		public Point p0;
		public Point p1;


	}

}
